//----------------------------------------------------------------------------
#include <stdio.h>
#include <intrin.h>

#if defined (_MSC_VER) // Microsoft
typedef unsigned long uint32_t;
typedef signed long int32_t;
typedef unsigned long long uint64_t;
typedef signed long long int64_t;
typedef signed long int32_t;
typedef unsigned char uint8_t;
#else // standard C
#include <stdint.h>
#endif

//---------------------------------------------------------------------------

typedef struct
   {
   uint64_t mask32     [2], mask64     [2], mask128     [2], mask256     [4], mask512     [8], mask1024     [16], mask2048     [32];
   uint64_t expected32 [2], expected64 [2], expected128 [2], expected256 [4], expected512 [8], expected1024 [16], expected2048 [32];
   uint64_t initial    [32];
   }
TEST_DATA;

//---------------------------------------------------------------------------

uint64_t queryPerformanceCounter (void);
uint64_t queryPerformanceFrequency (void);
char *cyclesText (uint64_t elapsedCount, uint64_t cpuSpeed, uint64_t loops);

void lfsrGpr (TEST_DATA *testData, int loops, uint64_t cpuSpeed);
void lfsrXmm (TEST_DATA *testData, int loops, uint64_t cpuSpeed);
void lfsrYmm (TEST_DATA *testData, int loops, uint64_t cpuSpeed);

//----------------------------------------------------------------------------
